#-------------------------------------------------------------------#
# ChatCE.pl							    #
#-------------------------------------------------------------------#
# Chat CE 4 YaBB24						    #
# Version 1.2							    #
# by Carsten Dalgaard						    #
#-------------------------------------------------------------------#
# Copyright: 2009 'Carsten Dalgaard' - All Rights Reserved	    #
# Released: October 9, 2009					    #
# e-mail: carsten.dalgaard@gmail.com				    #
#-------------------------------------------------------------------#
# Any redistribution of this script without the expressed written   #
# consent of 'Carsten Dalgaard' is strictly prohibited. Copying     #
# any	of the code contained within this script and claiming it as #
# your own is also prohibited.					    #
#-------------------------------------------------------------------#
# By using this script you agree to indemnify 'Carsten Dalgaard'    #
# from any liability that might arise from its use.		    #
#-------------------------------------------------------------------#
# You may not remove any of these header notices.		    #
#-------------------------------------------------------------------#

$chatceplver = 'YaBB 2.4 $Revision: 1.2 $';
if ($action eq 'detailedversion') { return 1; }

if ($iamguest || !$enablechat) { &fatal_error('no_access'); }

&LoadLanguage("ChatCE");

$message_term = 120 if $message_term eq '';
$part_term = 15 if $part_term eq '';
$update_freq = 10 if $update_freq eq '';
$MaxChatLen = 300 if $MaxChatLen eq '';

sub chatCE_open {
	my $chatupdate = $update_freq * 1000;
	my ($catcptions, $boardcount);
	(@excllist) = split(/\, /, $ChatRoom);


	if (-e "$vardir/chatce.log") {
		fopen(LOG, "$vardir/chatce.log");
		%participant = map /(.*)\t(.*)/, <LOG>;
		fclose(LOG);
	}

	$defselected="";
	$actroom = "";
	if($INFO{'room'} ne '') {
		$actroom = $INFO{'room'};
	}
	else {
		$actroom = qq~chatcedefault~;
	}
	if($actroom eq "chatcedefault") {
		$actname = qq~$chatce_txt{'chatdefault'}~;
		$defselected = qq~ selected="selected"~;
	}
	else {
		($actname, undef, undef) = split(/\|/, $board{"$actroom"});
	}

	$catcptions .= qq~<optgroup label="$chatce_txt{'chatroom'}">~;
	$catcptions .= qq~<option value="chatcedefault"$defselected>$chatce_txt{'chatdefault'}</option>\n~;
	$catcptions .= qq~</optgroup>~;

	$boardcount = 0;

	foreach $catid (@categoryorder) {
		my ($catname, $catperms, $catallowcol, $catimage) = split(/\|/, $catinfo{"$catid"});
		&ToChars($catname);
		$cataccess = &CatAccess($catperms);
		if (!$cataccess) { next; }
		$testcatid = $catid . "_cat";
		$usecat = 1;
		foreach (@excllist) {
			if ($_ eq $testcatid) { $usecat = 0; }
		}
		if (!$usecat) { next; }
		$firstboard = 1;
		$isoptgroup = 0;
		$boardlist = $cat{$catid};
		(@bdlist) = split(/\,/, $boardlist);
		foreach $curboard (@bdlist) {
			$useboard = 1;
			foreach (@excllist) {
				if ($_ eq $curboard) { $useboard = 0; }
			}
			if (!$useboard) { next; }
			if ($annboard eq $curboard && !$iamadmin && !$iamgmod) { next; }
			my ($boardname, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
			my $access = &AccessCheck($curboard, '', $boardperms);
			if (!$iamadmin && $access ne "granted" && $boardview != 1) { next; }
			if($firstboard) { $catcptions .= qq~<optgroup label="$catname">~; $isoptgroup = 1; }
			$selected="";
			if($curboard eq $actroom) { $selected = qq~ selected="selected"~; }
			$catcptions .= qq~<option value="$curboard"$selected>$boardname</option>\n~;
			$firstboard = 0;
			$boardcount++;
		}
		if($isoptgroup) { $catcptions .= qq~</optgroup>~; }
	}

	if($FORM{'tmpmessage'}) {
		$tmpmessage = $FORM{'tmpmessage'};
		$tmpmessage =~ s/[\r\n]//ig;
		$tmpmessage =~ s/(\<a href=)(.*?)(\>)/$1$2 target="_blank"$3/ig;
		$tmpmessage =~ s/&nbsp;/ /ig;
		&ToHTML($tmpmessage);

		if (-e "$vardir/$actroom.chat") {
			fopen(CHAT, "$vardir/$actroom.chat");
			%shouts = map /(.*)\t(.*)/, <CHAT>;
			fclose(CHAT);
		}

		$shouts{$date} = "$username|$tmpmessage";
	
		fopen(CHAT, ">$vardir/$actroom.chat");
		print CHAT map "$_\t$shouts{$_}\n", keys %shouts;
		fclose(CHAT);
	}

	$iammod = 0;
	%moderators = ();
	$showmods = '';
	foreach my $curuser (split(/, ?/, ${$uid.$actroom}{'mods'})) {
		if ($username eq $curuser) { $iammod = 1; }
		if (!${$uid.$curuser}{'password'}) { &LoadUser($curuser); }
		$moderators{$curuser} = $curuser;
		$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$curuser}" target="_top">${$uid.$curuser}{'realname'}</A>, ~;
	}
	if (keys %moderators == 1) { $showmods = qq~<b>$chatce_txt{'moderator'}:</b><br />$showmods~; }
	elsif (keys %moderators != 0) { $showmods = qq~<b>$chatce_txt{'moderators'}:</b><br />$showmods~; }
	$showmods =~ s/, \Z//;
	undef %moderators;

	if (!${$uid.$username}{'password'}) { &LoadUser($username); }

	%moderatorgroups = ();
	$showmodgroups = '';
	foreach my $curgroup (split(/, /, ${$uid.$actroom}{'modgroups'})) {
		if (${$uid.$username}{'position'} eq $curgroup) { $iammod = 2; }
		foreach (split(/,/, ${$uid.$username}{'addgroups'})) {
			if ($_ eq $curgroup) { $iammod = 2; last; }
		}
		($thismodgrp, undef) = split(/\|/, $NoPost{$curgroup}, 2);
		$moderatorgroups{$curgroup} = $thismodgrp;
		$showmodgroups .= qq~$thismodgrp, ~;
	}

	if (scalar keys %moderatorgroups == 1) { $showmodgroups = qq~<b>$chatce_txt{'modgroup'}:</b><br />$showmodgroups~; }
	elsif (scalar keys %moderatorgroups != 0) { $showmodgroups = qq~<b>$chatce_txt{'modgroups'}:</b><br />$showmodgroups~; }
	$showmodgroups =~ s/, \Z//;
	undef %moderatorgroups;

	if ($showmodgroups eq "" && $showmods eq "") { $showmodgroups = qq~<br />~; }
	if ($showmodgroups ne "" && $showmods ne "") { $showmods .= qq~<br />~; }

	if($iamadmin) { $iammod = 4; }
	if($iamgmod) { $iammod = 3; }


	$participant{$username} = qq~$date|$actroom|$iammod~;

	fopen(LOG, ">$vardir/chatce.log");
	print LOG map "$_\t$participant{$_}\n", keys %participant;
	fclose(LOG);
	undef %participant;

	print qq~Content-type: text/html\n\n~;
	print qq~<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
	<title>Chat CE</title>
	<meta http-equiv="Content-Type" content="text/html; charset=$yycharset" />
	<link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />
	<script language="JavaScript1.2" type="text/javascript"> 
	<!--
	//force no cache
	if ((navigator.appVersion.substring(0,1) == "5" && navigator.userAgent.indexOf('Gecko') != -1) || navigator.userAgent.search(/Opera/) != -1) {
		document.write('<meta http-equiv="pragma" CONTENT="no-cache" />');
	}

	// -->
	</script>

	</head>
	<body class="windowbg2" style="min-width: 600px; margin: 0px; padding: 0px; background-image: none;">
	<table width="100%" cellpadding="3" cellspacing="0" border="0">
	<tr>
		<td class="catbg" align="left" width="100%">
			&nbsp;<img src='$modimgurl/chatce/chat1.gif' alt="$chatce_txt{'chatbox'}" title="$chatce_txt{'chatbox'}" border="0" style="vertical-align: middle; margin-bottom: 1px;" /> <b>$chatce_txt{'chatbox'} - $actname</b>
		</td>
	</tr>
	</table>
	<table cellpadding="0" cellspacing="0" border="0" width="100%" align="center">
	<tr>
		<td class="windowbg2" width="430">
			<div class="bordercolor" style="width: 381px; height: 298px; margin-left: auto; margin-right: auto; margin-top: 5px; padding: 0px;">
			<iframe frameborder="0" scrolling="no" name="cdshouthtm" id="cdshouthtm" style="width: 381px; height: 298px;"></iframe>
			</div>
			<div style="width: 383px; height: 20px; margin-top: 5px; margin-bottom: 3px; margin-left: auto; margin-right: auto; text-align: center;">
			<img src="$modimgurl/chatce/cdsdown.gif" height="18" width="22" border="0" alt="$chatce_txt{'scrolldown'}" title="$chatce_txt{'scrolldown'}" style="cursor: pointer; vertical-align: middle; display: inline;" onmousedown="shoutscroll=4" onmouseup="shoutscroll=0" />
			<img src="$modimgurl/chatce/cdsstop.gif" name="udtbutton" id="udtbutton" height="18" width="22" border="0" alt="$chatce_txt{'stopupdate'}" title="$chatce_txt{'stopupdate'}" style="cursor: pointer; vertical-align: middle; display: inline;" onclick="setChatUpdate(); return false;" />
			<img src="$modimgurl/chatce/cdsup.gif" height="18" width="22" border="0" alt="$chatce_txt{'scrollup'}" title="$chatce_txt{'scrollup'}" style="cursor: pointer; vertical-align: middle; display: inline;" onmousedown="shoutscroll=-4" onmouseup="shoutscroll=0" />
			</div>
		</td>
		<td class="windowbg" rowspan="2" valign="top">~;
			if($boardcount) {
				print qq~<div class="small" style="width: 180px; font-style: italic; margin-top: 5px; margin-left: auto; margin-right: auto;">
				<select name="ChatRoom" id="ChatRoom" onchange="if(this.options[this.selectedIndex].value) roomUpdate(this.options[this.selectedIndex].value)" style="width: 180px; font-size: 10px; vertical-align: top;">
					$catcptions
				</select>
				</div>
				<div class="small" style="width: 180px; font-style: italic; margin-top: 5px; margin-left: auto; margin-right: auto;">
				$showmods $showmodgroups
				</div>~;
			}
			print qq~<div class="small" style="width: 180px; font-style: italic; margin-top: 5px; margin-left: auto; margin-right: auto;">
			<b>$chatce_txt{'participants'}</b><br />
			<iframe frameborder="0" name="participants" id="participants" style="width: 180px; height: 300px; margin-top: 2px; padding: 0px;"></iframe>
			</div>
		</td>
	</tr>
	<tr>
		<td class="windowbg2" width="430">
			<div style="width: 383px; height: 22px; margin-left: auto; margin-right: auto; border: 1px solid gray; border-bottom: 0px;">
			~;
			print qq~<img src='$defaultimagesdir/bold.gif' valign='top' id='bold' width='23' height='22' border='0' alt='$editor_txt{'19'}' title='$editor_txt{'19'}' style='float: left; cursor: pointer; vertical-align: middle;' onclick='formatText(this.id);' />~;
			print qq~<img src='$defaultimagesdir/italicize.gif' valign='top' id='italic' width='23' height='22' border='0' alt='$editor_txt{'20'}' title='$editor_txt{'20'}' style='float: left; cursor: pointer; vertical-align: middle;' onclick='formatText(this.id);' />~;
			print qq~<img src='$defaultimagesdir/underline.gif' valign='top' id='underline' width='23' height='22' border='0' alt='$editor_txt{'21'}' title='$editor_txt{'21'}' style='float: left; cursor: pointer; vertical-align: middle;' onclick='formatText(this.id);' />~;
			print qq~<img src='$defaultimagesdir/strike.gif' valign='top' id='strikethrough' width='23' height='22' border='0' alt='$editor_txt{'22'}' title='$editor_txt{'22'}' style='float: left; cursor: pointer; vertical-align: middle;' onclick='formatText(this.id);' />~;
			print qq~<img src='$defaultimagesdir/sup.gif' valign='top' id='superscript' width='23' height='22' border='0' alt='$editor_txt{'10'}' title='$editor_txt{'10'}' style='float: left; cursor: pointer; vertical-align: middle' onclick='formatText(this.id);' />~;
			print qq~<img src='$defaultimagesdir/sub.gif' valign='top' id='subscript' width='23' height='22' border='0' alt='$editor_txt{'11'}' title='$editor_txt{'11'}' style='float: left; cursor: pointer; vertical-align: middle' onclick='formatText(this.id);' />~;
			print qq~<span style="float: left; height: 22px; width: 130px; background-image: url($modimgurl/chatce/blankbt.gif);"><select name="FontName" id="FontName" onchange="if(this.options[this.selectedIndex].value) formatText(this.id, this.options[this.selectedIndex].value)" style="width: 122px; margin-left: 4px; margin-top: 2px; font-size: 10px; vertical-align: middle;">~;
				print qq~<option value="">Verdana</option>
				<option value="">-----</option>
				<option value="Microsoft Sans Serif">MS Sans Serif</option>
				<option value="Verdana" selected="selected">Verdana</option>
				<option value="Arial">Arial</option>
				<option value="Tahoma">Tahoma</option>
				<option value="Lucida Sans">Lucida Sans</option>
				<option value="Times New Roman">Times New Roman</option>
				<option value="Georgia">Georgia</option>
				<option value="Courier">Courier</option>
				<option value="Courier New">Courier New</option>
				<option value="Bitstream Vera Sans Mono">Bitstream</option>
				<option value="Comic Sans MS">Comic Sans MS</option>
				<option value="Bradley Hand ITC">Bradley Hand ITC</option>
				<option value="Tempus Sans ITC">Tempus Sans ITC</option>
				<option value="Impact">Impact</option>
				<option value="Papyrus">Papyrus</option>~;
			print qq~</select></span>~;
			print qq~<img src='$defaultimagesdir/palette1.gif' valign='top' id='forecolor' width='23' height='22' border='0' alt='$editor_txt{'23'}' title='$editor_txt{'23'}' style='float: left; cursor: pointer; vertical-align: middle' onclick='window.open("$scripturl?action=cdchatpalette;task=forecolor","","height=308,width=302,menubar=no,toolbar=no,scrollbars=no");' />~;
			print qq~<img src='$modimgurl/chatce/bgcolor.gif' valign='top' id='HiliteColor' width='23' height='22' border='0' alt='$editor_txt{'24'}' title='$editor_txt{'24'}' style='float: left; cursor: pointer; vertical-align: middle' onclick='window.open("$scripturl?action=cdchatpalette;task=HiliteColor","","height=308,width=302,menubar=no,toolbar=no,scrollbars=no");' />~;
			print qq~<img src='$defaultimagesdir/me.gif' valign='top' id='me' width='23' height='22' border='0' alt='$editor_txt{'14'}' title='$editor_txt{'14'}' style='float: left; cursor: pointer; vertical-align: middle' onclick='insertMe();' />~;
			print qq~<img src='$defaultimagesdir/url.gif' id='insertlink' valign='top' width='23' height='22' border='0' style='float: left; cursor: pointer; vertical-align: middle;' alt='$chatce_txt{'hyperlink'}' title='$chatce_txt{'hyperlink'}' onclick='newLinkWindow("$scripturl?action=createlink;task=hyper","60","460");' />~;
			print qq~<img src='$defaultimagesdir/email2.gif' id='insertemail' valign='top' width='23' height='22' border='0' style='float: left; cursor: pointer; vertical-align: middle;' alt='$editor_txt{'3'}' title='$editor_txt{'3'}' onclick='newLinkWindow("$scripturl?action=createlink;task=email","60","460");' />~;
			print qq~</div>
			<form action="$scripturl?action=cdchatupdate;room=$actroom" method="post" name="shoutmodify" onsubmit="updateTextArea()">
			<textarea id="tmpmessage" name="tmpmessage" rows="1" cols="1" style="display: none;"></textarea>
			<div class="windowbg2" style="width: 383px; height: 50px; border: 1px solid gray; margin-left: auto; margin-right: auto; padding: 0px;">
			<iframe frameborder="0" name="wysmessage" id="wysmessage" style="width: 375px; height: 42px; padding: 0px; font-size: 12px;"></iframe>
			</div>
			<div class="windowbg" style='width: 383px; margin-left: auto; margin-right: auto; border: 1px solid gray; border-top: 0px; text-align: left;'>
			<span class="small" title="$chatce_txt{'remchar'}" style="cursor: default; border-right: 1px solid gray; padding: 0px 0px 1px 6px; text-align: center;">
			<img src="$defaultimagesdir/green1.gif" name="chrwarn" id="chrwarn" height="8" width="8" border="0" alt="$chatce_txt{'remchar'}" title="$chatce_txt{'remchar'}" style="vertical-align: middle;" />
			<input type="text" value="$MaxChatLen" size="3" name="msgCL" id="msgCL" class="windowbg" title="$chatce_txt{'remchar'}" style="cursor: default; border: 0px; font-size: 10px; width: 28px; padding: 1px; vertical-align: middle;" readonly="readonly" />
			</span>
			<span class="small" id="status" style="padding: 0px 0px 0px 6px; vertical-align: middle; text-align: left;"></span>
			</div>
			<div class="windowbg2" style='width: 383px; margin-left: auto; margin-right: auto; text-align: center; padding: 6px 0px 0px 0px;'>
			<img src='$defaultimagesdir/smiley.gif' height='18' width='18' id='smiley' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'101'}' title='$editor_txt{'101'}' border='0' />
			<img src='$defaultimagesdir/wink.gif' height='18' width='18' id='wink' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'102'}' title='$editor_txt{'102'}' border='0' />
			<img src='$defaultimagesdir/cheesy.gif' height='18' width='18' id='cheesy' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'103'}' title='$editor_txt{'103'}' border='0' />
			<img src='$defaultimagesdir/grin.gif' height='18' width='18' id='grin' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'104'}' title='$editor_txt{'104'}' border='0' />
			<img src='$defaultimagesdir/angry.gif' height='18' width='18' id='angry' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'105'}' title='$editor_txt{'105'}' border='0' />
			<img src='$defaultimagesdir/sad.gif' height='18' width='18' id='sad' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'106'}' title='$editor_txt{'106'}' border='0' />
			<img src='$defaultimagesdir/shocked.gif' height='18' width='18' id='shocked' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'107'}' title='$editor_txt{'107'}' border='0' />
			<img src='$defaultimagesdir/cool.gif' height='18' width='18' id='cool' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'108'}' title='$editor_txt{'108'}' border='0' />
			<img src='$defaultimagesdir/huh.gif' height='18' width='18' id='huh' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'109'}' title='$editor_txt{'109'}' border='0' />
			<img src='$defaultimagesdir/rolleyes.gif' height='18' width='18' id='rolleyes' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'110'}' title='$editor_txt{'110'}' border='0' />
			<img src='$defaultimagesdir/tongue.gif' height='18' width='18' id='tongue' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'111'}' title='$editor_txt{'111'}' border='0' />
			<img src='$defaultimagesdir/embarassed.gif' height='18' width='18' id='embarassed' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'112'}' title='$editor_txt{'112'}' border='0' />
			<img src='$defaultimagesdir/lipsrsealed.gif' height='18' width='18' id='lipsrsealed' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'113'}' title='$editor_txt{'113'}' border='0' />
			<img src='$defaultimagesdir/undecided.gif' height='18' width='18' id='undecided' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'114'}' title='$editor_txt{'114'}' border='0' />
			<img src='$defaultimagesdir/kiss.gif' height='18' width='18' id='kiss' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'115'}' title='$editor_txt{'115'}' border='0' />
			<img src='$defaultimagesdir/cry.gif' height='18' width='18' id='cry' onclick='insertSmiley(this.src, this.title);' style='cursor: pointer;' valign='bottom' alt='$editor_txt{'116'}' title='$editor_txt{'116'}' border='0' />
			</div>
			<div style='width: 385px; margin-left: auto; margin-right: auto; text-align: center; margin-top: 4px;'>
			<input type="submit" value="$editor_txt{'addchat'}" class="button" style="width: 191px; cursor: pointer;" /><input type="button" value="$editor_txt{'clearchat'}" name="clear" id="clear" class="button" style="width: 191px; margin-left: 3px; cursor: pointer;" onclick="showEditor('clear');" />
			</div>
			<input type="hidden" name="formsession" value="$formsession" />
			</form><br />
		</td>
	</tr>
	</table>

	<script language="JavaScript1.2" type="text/javascript">
	<!--

	function formatText(id, selected) {
		doSetfocus();
		if (id == "FontName") {
			document.getElementById("wysmessage").contentWindow.document.execCommand(id, false, selected);
			document.getElementById(id).options[0].text = selected;
			document.getElementById(id).options[0].selected = true;
		}
		else if (selected) {
			document.getElementById("wysmessage").contentWindow.document.execCommand(id, false, selected);
		}
		else {
			document.getElementById('wysmessage').contentWindow.document.execCommand(id, false, null);
			updateButtons();
		}
		doSetfocus();
	}

	function insertSmiley(theimg, thetitle) {
		doSetfocus();
		if (navigator.appName == "Microsoft Internet Explorer") {
			var htm = '<img src="' + theimg + '" border="0" alt="' + thetitle + '" title="' + thetitle + '">';
			document.getElementById('wysmessage').contentWindow.document.selection.createRange().pasteHTML(htm);
		}
		else {
			document.getElementById('wysmessage').contentWindow.document.execCommand("InsertImage", false, theimg);
		}
		doSetfocus();
		CharsLeft();
	}

	var displayname = "${$uid.$username}{'realname'}";

	function insertMe() {
		doSetfocus();
		var html = '<span><span style="color: #ff0000;">*' + displayname + '</span>&nbsp;</span>';
		if (navigator.appName == "Microsoft Internet Explorer") {
			document.getElementById('wysmessage').contentWindow.document.selection.createRange().pasteHTML(html);
		}
		else {
			var fragment = document.getElementById('wysmessage').contentWindow.document.createDocumentFragment();
			var element = document.getElementById('wysmessage').contentWindow.document.createElement("div");
			element.innerHTML = html;
			while (element.firstChild) fragment.appendChild(element.firstChild);
			var node = insertNodeAtSel(fragment);
		}
		doSetfocus();
		CharsLeft();
	}

	function insertNodeAtSel(insertNode) {
		var sel = document.getElementById('wysmessage').contentWindow.getSelection();
		var range = sel.getRangeAt(0);
		sel.removeAllRanges();
		range.deleteContents();
		var container = range.startContainer;
		var pos = range.startOffset;
		var afterNode;
		switch (container.nodeType) {
		case 3:
			if (insertNode.nodeType==3) {
				container.insertData(pos, insertNode.nodeValue);
			}
			else {
				container = container.splitText(pos);
				container.parentNode.insertBefore(insertNode, container);
			}
			afterNode = container;
			break;
		case 1:
			container.insertBefore(insertNode, container.childNodes[pos]);
			afterNode = container.childNodes[pos];
			break;
		}
		var afterPos = pos+insertNode.length;
		if(navigator.appName == "Opera") {
			range = document.createRange();
		}
		else {
			range.setEndAfter(afterNode, afterPos);
			range.setStartAfter(afterNode, afterPos);
		}
		sel.addRange(range);
		doSetfocus();
	}

	function updateButtons() {
		var boldtxt = "$editor_txt{'19'}";
		var italtxt = "$editor_txt{'20'}";
		var undertxt = "$editor_txt{'21'}";
		var striketxt = "$editor_txt{'22'}";
		var suptxt = "$editor_txt{'10'}";
		var subtxt = "$editor_txt{'11'}";
		document.getElementById('bold').src = '$defaultimagesdir/bold.gif';
		document.getElementById('italic').src = '$defaultimagesdir/italicize.gif';
		document.getElementById('underline').src = '$defaultimagesdir/underline.gif';
		document.getElementById('strikethrough').src = '$defaultimagesdir/strike.gif';
		document.getElementById('superscript').src = '$defaultimagesdir/sup.gif';
		document.getElementById('subscript').src = '$defaultimagesdir/sub.gif';
		var ifrm = document.getElementById('wysmessage').contentWindow;
		var doc = ifrm.document;
		var sel = null;
		if(ifrm.getSelection) sel = ifrm.getSelection();
		else if (doc.getSelection) sel = doc.getSelection();
		else if (doc.selection) sel = doc.selection;
		var range = sel.createRange ? sel.createRange() : sel.getRangeAt(0);		
		var tag = getTag(range);
		if(tag == null) return;
		var node = getParent(tag);
		var nodeTree = new Array(tag);
		var ii = 1;
		while(node != null && node.nodeName != "#document") {
			nodeTree[ii] = node;
			node = getParent(node);			
			ii++;
		}
		if(nodeTree == null) return;
		var nodeatt = "";
		var max = nodeTree.length - 1;
		var buttonid = '';
		var nodelink = '';
		for(var i=max; i>=0; i--) {
			if(nodeTree[i].nodeName != "HTML" && nodeTree[i].nodeName != "BODY" && nodeTree[i].nodeName != "BR") {
				var styleatt;
				if(navigator.appName == "Microsoft Internet Explorer") styleatt = nodeTree[i].style['cssText'].toLowerCase();		
				else styleatt = nodeTree[i].getAttribute("style");
				if(!styleatt) nodeatt = nodeTree[i].nodeName;
				else nodeatt = styleatt;
				if(nodeatt == 'STRONG' || nodeatt == 'B' || nodeatt.match(/font-weight\: bold\;/i)) {
					buttonid += 'bold ';
					nodelink += '<a href="javascript:selectNode(' + i + ');">' + boldtxt + '</a> ';
				}
				if(nodeatt == 'EM' || nodeatt == 'I' || nodeatt.match(/font-style\: italic\;/i)) {
					buttonid += 'italic ';
					nodelink += '<a href="javascript:selectNode(' + i + ');">' + italtxt + '</a> ';
				}
				if(nodeatt == 'U' || nodeatt.match(/underline/i)) {
					buttonid += 'underline ';
					nodelink += '<a href="javascript:selectNode(' + i + ');">' + undertxt + '</a> ';
				}
				if(nodeatt == 'STRIKE' || nodeatt.match(/line-through/i)) {
					buttonid += 'strike ';
					nodelink += '<a href="javascript:selectNode(' + i + ');">' + striketxt + '</a> ';
				}
				if(nodeatt == 'SUP') {
					buttonid += 'sup ';
					nodelink += '<a href="javascript:selectNode(' + i + ');">' + suptxt + '</a> ';
				}
				if(nodeatt == 'SUB') {
					buttonid += 'sub ';
					nodelink += '<a href="javascript:selectNode(' + i + ');">' + subtxt + '</a> ';
				}
			}
		}
		if( buttonid.match(/bold/i) ) document.getElementById('bold').src = '$modimgurl/chatce/boldsel.gif';
		if( buttonid.match(/italic/i) ) document.getElementById('italic').src = '$modimgurl/chatce/italicsel.gif';
		if( buttonid.match(/underline/i) ) document.getElementById('underline').src = '$modimgurl/chatce/underlinesel.gif';
		if( buttonid.match(/strike/i) ) document.getElementById('strikethrough').src = '$modimgurl/chatce/strikesel.gif';
		if( buttonid.match(/sup/i) ) document.getElementById('superscript').src = '$modimgurl/chatce/supsel.gif';
		if( buttonid.match(/sub/i) ) document.getElementById('subscript').src = '$modimgurl/chatce/subsel.gif';
		document.getElementById('status').innerHTML = nodelink;
	}

	function selectNode(level) {
		doSetfocus();
		var ifrm = document.getElementById('wysmessage').contentWindow;
		var doc = ifrm.document;
		var sel = null;
		if(ifrm.getSelection) sel = ifrm.getSelection();
		else if (doc.getSelection) sel = doc.getSelection();
		else if (doc.selection) sel = doc.selection;
		var range = sel.createRange ? sel.createRange() : sel.getRangeAt(0);		
		var parentnode = getTag(range);
		var i = 0;
		for (var node=parentnode; (node && (node.nodeType == 1)); node=node.parentNode) {
			if (i == level) nodeSelection(node);
			i++;
		}
		updateButtons();
	}

	function nodeSelection(node) {
		var ifrm = document.getElementById('wysmessage').contentWindow;
		var doc = ifrm.document;
		var sel = null;
		if(ifrm.getSelection) sel = ifrm.getSelection();
		else if (doc.getSelection) sel = doc.getSelection();
		else if (doc.selection) sel = doc.selection;
		var range = sel.createRange ? sel.createRange() : sel.getRangeAt(0);
		if(navigator.appName != "Microsoft Internet Explorer") {
			if (node.nodeName == "BODY") range.selectNodeContents(node);
			else range.selectNode(node);
			if (sel) {
				sel.removeAllRanges();
				sel.addRange(range);
			}
		}
		else {
			range = doc.body.createTextRange();
			if (range) {
				range.collapse();
				if (range.moveToElementText) {
					try {
						range.moveToElementText(node);
						range.select();
					} catch(e) {
						try {
							range = doc.body.createTextRange();
							range.moveToElementText(node);
							range.select();
						}
						catch(e) {}
					}
				} else {
					try {
						range = doc.body.createTextRange();
						range.moveToElementText(node);
						range.select();
					}
					catch(e) {}
				}
			}
		}
	}

	function getTag(range) {
		try {
			if(navigator.appName != "Microsoft Internet Explorer") {
				var node = range.startContainer;
				var pos = range.startOffset;
				if(node.nodeType != 3) node = node.childNodes[pos];
				if(node.nodeName && node.nodeName.search(/#/) != -1) return node.parentNode;
				return node;
			}
			else {
				if(range.length > 0) return range.item(0);
				else if(range.parentElement()) return range.parentElement();
			}
			return null;
		}
		catch(e) {
			return null;
		}
	}

	function getParent(element) {
		if(element.parentNode) return element.parentNode;
		return null;
	}

	var noalert = true, gralert = false, rdalert = false, clalert = false;
	
	function CharsLeft() {
		var getText = document.getElementById("wysmessage").contentWindow.document.body.innerHTML.toString();
		getText = getText.replace(/\<img(.*?)\>/ig, " ");
		getText = getText.replace(/\<(.*?)\>/ig, "");
		getText = getText.replace(/\&nbsp\;/ig, " ");
		var textleng = getText.length;
		var maxLength = $MaxChatLen;
		var greenAlert = parseInt((maxLength * 20) / 100);
		var redAlert = parseInt(greenAlert / 2);
		if (textleng > maxLength) {
			document.getElementById("wysmessage").contentWindow.document.body.innerHTML = document.getElementById("wysmessage").contentWindow.document.body.innerHTML.substring(0,maxLength);
			var charleft = 0;
		} else {
			charleft = maxLength - textleng;
		}
		document.getElementById("msgCL").value = charleft;
		if (charleft >= greenAlert && noalert) { noalert = false; gralert = true; rdalert = true; clalert = true; document.images.chrwarn.src="$defaultimagesdir/green1.gif"; }
		if (charleft < greenAlert && charleft >= redAlert && gralert) { noalert = true; gralert = false; rdalert = true; clalert = true; document.images.chrwarn.src="$defaultimagesdir/green0.gif"; }
		if (charleft < redAlert && charleft > 0 && rdalert) { noalert = true; gralert = true; rdalert = false; clalert = true; document.images.chrwarn.src="$defaultimagesdir/red0.gif" }
		if (charleft == 0 && clalert) { noalert = true; gralert = true; rdalert = true; clalert = false; document.images.chrwarn.src="$defaultimagesdir/red1.gif"; }
	}

	var thisroom = '$actroom';
	var chupdate = '$chatupdate';

	function chatUpdate() {
		document.getElementById('cdshouthtm').src="$scripturl?action=cdupdatechat;room=" + thisroom;
		document.getElementById('participants').src="$scripturl?action=cdupdatepart;room=" + thisroom;
		IDupdtae = setTimeout("chatUpdate()",chupdate);
	}

	function roomUpdate(theroom) {
		location.href = "$scripturl?action=cdchatopen;room=" + theroom;
	}

	var doUpdate = true;

	function setChatUpdate() {
		if(doUpdate) {
			chatUpdate();
			document.getElementById('udtbutton').src = '$modimgurl/chatce/cdsstop.gif';
			document.getElementById('udtbutton').alt = '$chatce_txt{"stopupdate"}';
			document.getElementById('udtbutton').title = '$chatce_txt{"stopupdate"}';
			doUpdate = false;
		}
		else {
			clearTimeout(IDupdtae);
			document.getElementById('udtbutton').src = '$modimgurl/chatce/cdsupdate.gif';
			document.getElementById('udtbutton').alt = '$chatce_txt{"update"}';
			document.getElementById('udtbutton').title = '$chatce_txt{"update"}';
			doUpdate = true;
		}
		doSetfocus();
	}

	function doSetfocus() {
		if (navigator.userAgent.indexOf('Firefox') !=-1) frames['wysmessage'].focus();
		else if (window.opera) document.getElementById("wysmessage").contentWindow.document.body.focus();
		else document.getElementById("wysmessage").contentWindow.focus();
	}

	function doEditable() {
		document.getElementById('wysmessage').contentWindow.document.body.contentEditable = true;
		document.getElementById('wysmessage').contentWindow.document.designMode = 'on';
		doSetfocus();
	}

	function showEditor(todo) {
		var tophtm = '<html>';
		tophtm += '<head>';
		tophtm += '<title>Editor</title>';
		tophtm += '<meta http-equiv="Content-Type" content="text/html; charset=$yycharset" />';
		tophtm += '<link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />';
		tophtm += '</head>';
		tophtm += '<body class="windowbg2" style="width: 350px; min-width: 350px; height: 36px; font-size: 12px; border: 0px solid black; margin: 3px; padding: 0px; background-image: none;"></body>';
		tophtm += '</html>';
		document.getElementById('wysmessage').contentWindow.document.open();
		document.getElementById('wysmessage').contentWindow.document.write(tophtm);
		document.getElementById('wysmessage').contentWindow.document.close();
		if(navigator.appName == "Microsoft Internet Explorer") document.getElementById('wysmessage').contentWindow.focus();
		doEditable();
		if (document.getElementById('wysmessage').contentWindow.document.attachEvent) {
			document.getElementById('wysmessage').contentWindow.document.attachEvent("onmouseup", function no_name() { updateButtons(); });
			document.getElementById('wysmessage').contentWindow.document.attachEvent("onkeyup", function no_name(event) { CharsLeft(); if (event.keyCode == 37 || event.keyCode == 39) updateButtons(); });
		}
		else {
			document.getElementById('wysmessage').contentWindow.document.addEventListener("mouseup", function no_name() { updateButtons(); }, false);
			document.getElementById('wysmessage').contentWindow.document.addEventListener("keyup", function no_name(event) { CharsLeft(); if (event.keyCode == 37 || event.keyCode == 39) updateButtons(); }, false);
		}
		if(todo == 'clear') { updateButtons(); CharsLeft(); }
		if(todo == 'start') setChatUpdate();
		if (!window.opera) setTimeout("doEditable()",1000);
	}

	function updateTextArea() {
		document.getElementById('tmpmessage').value = document.getElementById("wysmessage").contentWindow.document.body.innerHTML;
	}

	function newLinkWindow(url, winheight, winwidth) {
		if (linkwin && linkwin.open && !linkwin.closed) linkwin.close();
		var linkwin=window.open(url,"linkwin","height=" + winheight + ",width=" + winwidth + ",resizable=yes");
	}

	showEditor('start');
	-->
	</script>

	</body>
	</html>
	~;
}


sub chatCE {
	my $theroom = '';
	if($INFO{'room'}) { $theroom = $INFO{'room'}; }

	$yymain .= qq~
	<div class="bordercolor" style="width: 630px; padding: 0px 1px 1px 1px; margin-left: auto; margin-right: auto;">
		<iframe frameborder="0" name="chatcemain" id="chatcemain" scrolling="no" style="width: 630px; height: 505px; padding: 0px; font-size: 12px;"></iframe>
	</div>

	<script language="JavaScript1.2" type="text/javascript">
	<!--
	var theroom = '$theroom';
	document.getElementById('chatcemain').src="$scripturl?action=cdchatopen;room=" + theroom;
	-->
	</script>
	~;

	$yynavigation = qq~&rsaquo; $chatce_txt{'chatbox'}~;
	$yytitle = $chatce_txt{'chatbox'};
	&template;
}

sub UpdateChat {

	$thisroom = $INFO{'room'};

	if (-e "$vardir/$thisroom.chat") {
		fopen(CHAT, "$vardir/$thisroom.chat");
		%shouts = map /(.*)\t(.*)/, <CHAT>;
		fclose(CHAT);
	}

	if($INFO{'delete'}) {
		$delthis = $INFO{'delete'};
		delete $shouts{$delthis};
	}

	my $iammodhere = '';
	foreach my $curuser (split(/, ?/, ${$uid.$thisroom}{'mods'})) {
		if ($username eq $curuser) { $iammodhere = 1; }
	}
	foreach my $curgroup (split(/, /, ${$uid.$thisroom}{'modgroups'})) {
		if (${$uid.$username}{'position'} eq $curgroup) { $iammodhere = 1; }
		foreach (split(/,/, ${$uid.$username}{'addgroups'})) {
			if ($_ eq $curgroup) { $iammodhere = 1; last; }
		}
	}

	&LoadCensorList;
	my $toold = $message_term * 60;

	if($removealert) { $rem_alert = qq~ onclick="return confirm('$chatce_txt{'remove'}');"~; }
	else { $rem_alert = ""; }

	$actcounter = 0;

print qq~Content-type: text/html\n\n~;
print qq~<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>ChatCE</title>
<meta http-equiv="Content-Type" content="text/html; charset=$yycharset" />
<link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />
</head>
<body class="windowbg2" style="min-width: 360px; margin: 0px; padding: 0px; background-image: none;">~;

	foreach $key (sort(keys(%shouts))) {
		if($key < ($date - $toold)) {
			delete $shouts{$key};
			next;
		}

		my $deletech = "";
		if($iamadmin || $iamgmod || $iammodhere) {
			$deletech = qq~<div class="small" style="float: left; width: 20px;">~;
			$deletech .= qq~<a href="$scripturl?action=cdupdatechat;room=$thisroom;delete=$key"$rem_alert><img src='$defaultimagesdir/im_delete.gif' alt="$chatce_txt{'remove'}" title="$chatce_txt{'remove'}" border="0" /></a>~;
			$deletech .= qq~</div>~;
		}

		($tmpuser, $tmpshout) = split(/\|/, $shouts{$key});
		&FromHTML($tmpshout);
		$tmpshout = &Censor($tmpshout);
		$thistime = &timeformat($key);

		if (!${$uid.$tmpuser}{'password'}) { &LoadUser($tmpuser); }
		$theuser = $format{$tmpuser};
print qq~
<div class="small" style="float: left; width: 356px; padding: 4px 0px 0px 4px;">&#8226; $thistime - $theuser</div>$deletech~;
print qq~
<div style="float: left; width: 370px; padding: 2px 4px 4px 8px; border-bottom: 1px dotted gray;">$tmpshout</div>~;
		$actcounter++;
	}

print qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function scrollshout() {
	if (window.parent.shoutscroll != 0) window.scrollBy(0, window.parent.shoutscroll);
}
	
setInterval("scrollshout()",10);

var dochi = document.documentElement.scrollHeight;
var clihi = document.documentElement.clientHeight;
if(dochi > clihi) window.scrollTo(0,(dochi - clihi));
-->
</script>
</body>
</html>~;

	fopen(CHAT, ">$vardir/$thisroom.chat");
	print CHAT map "$_\t$shouts{$_}\n", keys %shouts;
	fclose(CHAT);
	undef %shouts;
}

sub UpdateParticipants {

	$thisroom = $INFO{'room'};

	if (-e "$vardir/chatce.log") {
		fopen(LOG, "$vardir/chatce.log");
		%participant = map /(.*)\t(.*)/, <LOG>;
		fclose(LOG);
	}
	print qq~Content-type: text/html\n\n~;
	print qq~<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
	<title>Chat CE Participants</title>
	<meta http-equiv="Content-Type" content="text/html; charset=$yycharset" />
	<link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />
	</head>
	<body class="windowbg" style="min-width: 160px; margin: 0px; padding: 0px; background-image: none;">
	~;
	my $toold = $part_term * 60;
	foreach $thisuser (sort(keys(%participant))) {
		my($ontime, $onroom, $iammodhere) = split(/\|/, $participant{$thisuser});
		if($ontime < ($date - $toold)) {
			delete $participant{$thisuser};
			next;
		}
		if($onroom ne $thisroom) { next; }
		if($iammodhere == 1) { $moderators{$thisuser} = $thisuser; }
		if($username eq $thisuser) { &LoadMiniUser($thisuser); }
		else { if (!${$uid.$thisuser}{'password'}) { &LoadUser($thisuser); } }
		if(!$iamadmin && !$iamgmod && ${$uid.$thisuser}{'stealth'}) { next; }
		$theuser = $format{$thisuser} . (${$uid.$thisuser}{'stealth'} ? "*" : "");
		if($iammodhere == 1 || $iammodhere == 2) { $memstat = qq~<img src='$defaultimagesdir/starsilver.gif' alt="$chatce_txt{'moderator'}" title="$chatce_txt{'moderator'}" border="0" style="margin-left: 1px;" />~; }
		elsif($iammodhere == 3) { $memstat = qq~<img src='$defaultimagesdir/stargold.gif' alt="$chatce_txt{'gmod'}" title="$chatce_txt{'gmod'}" border="0" />~; }
		elsif($iammodhere == 4) { $memstat = qq~<img src='$defaultimagesdir/stargold.gif' alt="$chatce_txt{'admin'}" title="$chatce_txt{'admin'}" border="0" />~; }
		else { $memstat = qq~&#8226;~; }
		print qq~<div style="float: left; width: 180px; text-align: left; padding: 0px 0px 0px 0px;">
			<span class="small" style="float: left; width: 18px; text-align: center; vertical-align: middle;">$memstat</span>
			<span class="small" style="float: left; padding-left: 4px; vertical-align: middle;">$theuser</span><br />
		</div>~;
	}
	fopen(LOG, ">$vardir/chatce.log");
	print LOG map "$_\t$participant{$_}\n", keys %participant;
	fclose(LOG);
	undef %participant;
	print qq~
	</body>
	</html>
	~;
}

sub InsertLink {
	$linktype = $INFO{'task'};
	if($linktype eq "email") { $linktitle = qq~$editor_txt{'3'}~; $linkttext = qq~mailto:~; }
	else { $linktitle = qq~$chatce_txt{'hyperlink'}~; $linkttext = qq~http://~; }
	print qq~Content-type: text/html\n\n~;
	print qq~<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
	<title>$linktitle</title>
	<meta http-equiv="Content-Type" content="text/html; charset=$yycharset" />
	<link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />
	<script language="JavaScript1.2" type="text/javascript">
	<!--
	function insertHyperlink() {
		opener.document.getElementById("wysmessage").contentWindow.focus();
		var theLinktype = '$linkttext';
		theLink = theLinktype + document.getElementById('url').value;
		opener.document.getElementById('wysmessage').contentWindow.document.execCommand("Unlink", false, null);
		opener.document.getElementById('wysmessage').contentWindow.document.execCommand("createlink", false, theLink);
		window.close();
	}
	//-->
	</script>
	</head>
	<body class="windowbg" style="min-width: 460px; margin: 0px; padding: 0px;">
	<form>
	<table border="0" width="100%" cellspacing="0" cellpadding="3">
	<tr>
		<td class="catbg" align="left" width="100%">
			&nbsp;<img src='$modimgurl/chatce/chat1.gif' alt="$chatce_txt{'chatbox'}" title="$chatce_txt{'chatbox'}" border="0" style="vertical-align: middle; margin-bottom: 1px;" /> <b>$linktitle</b>
		</td>
	</tr>
	<tr>
	<td align="left" valign="middle" width="100%">
	<div class="small" id="mlform" name="mlform" style="width: 100%; text-align: center; margin-left: auto; margin-right: auto; margin-top: 3px; margin-bottom: 3px; padding: 3px;">
	<b>$linkttext</b> <input type="text" class="small" size="55" id="url" name="url" value="" style="width: 300px; vertical-align: middle;" /> <img src="$modimgurl/chatce/linkok.gif" border="0" alt="$editor_txt{'insert'}" title="$editor_txt{'insert'}" style="cursor: pointer; vertical-align: middle;" onclick="insertHyperlink();" /><img src="$modimgurl/chatce/linkcl.gif" border="0" alt="$editor_txt{'cancel'}" title="$editor_txt{'cancel'}" style="cursor: pointer; vertical-align: middle;" onclick="window.close();" />
	</div>
	</td>
	</tr>
	</table>
	</form>

	<script language="JavaScript1.2" type="text/javascript">
	<!--
		document.getElementById('url').focus();
	//-->
	</script>

	</body>
	</html>
	~;
}

sub ColorPicker {
$picktask = $INFO{'task'};
if($picktask eq "HiliteColor") {$titleextra = qq~Background Color~;}
else {$titleextra = qq~Font Color~;}
my $browser = $ENV{"HTTP_USER_AGENT"};
if($picktask eq "HiliteColor" && $browser =~ m/msie/i) { $picktask = qq~BackColor~; }
$headers .= "Content-type: text/html\n";
if ($yySetCookies) { $headers .= $yySetCookies; }
$headers .= "\n";
print $headers;
print qq~
<html>
<head>
<title>$titleextra Palette</title>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
<link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />

<script language="JavaScript1.2" type="text/javascript">
<!--
var picktask = '$picktask';

function tohex(i) {
	a2 = ''
	ihex = hexQuot(i);
	idiff = eval(i + '-(' + ihex + '*16)')
	a2 = itohex(idiff) + a2;
	while( ihex >= 16) {
		itmp = hexQuot(ihex);
		idiff = eval(ihex + '-(' + itmp + '*16)');
		a2 = itohex(idiff) + a2;
		ihex = itmp;
	} 
	a1 = itohex(ihex);
	return a1 + a2 ;
}

function hexQuot(i) {
	return Math.floor(eval(i +'/16'));
}

function itohex(i) {
 	if( i == 0) { aa = '0' }
	else { if( i == 1 ) { aa = '1' }
	else { if( i == 2 ) { aa = '2' }
	else { if( i == 3 ) { aa = '3' }
	else { if( i == 4 ) { aa = '4' }
	else { if( i == 5 ) { aa = '5' }
	else { if( i == 6 ) { aa = '6' }
	else { if( i == 7 ) { aa = '7' }
	else { if( i == 8 ) { aa = '8' }
	else { if( i == 9 ) { aa = '9' }
	else { if( i == 10) { aa = 'a' }
	else { if( i == 11) { aa = 'b' }
	else { if( i == 12) { aa = 'c' }
	else { if( i == 13) { aa = 'd' }
	else { if( i == 14) { aa = 'e' }
 	else { if( i == 15) { aa = 'f' }
	}}}}}}}}}}}}}}}
	return aa
}

function Pickshowcolor(color) {
	if ( c=color.match(/rgb\\((\\d+?)\\, (\\d+?)\\, (\\d+?)\\)/i) ) {
		var rhex = tohex(c[1]);
		var ghex = tohex(c[2]);
		var bhex = tohex(c[3]);
		var newcolor = '#'+rhex+ghex+bhex;
	}
	else {
		var newcolor = color;
	}
	window.opener.document.getElementById('wysmessage').contentWindow.document.execCommand(picktask, false, newcolor);
	window.close();
}

//-->
</script>

</head>
<body style="min-width: 300px;">

<div class="windowbg" style="position: absolute; top: 0px; left: 0px; width: 302px; height: 308px; border: 1px black outset;">
	<div style="position: relative; top: 4px; left: 5px; width: 289px; height: 209px; padding-left: 1px; padding-top: 1px; border: 0px; background-color: black;">
        ~;
	for ($z = 0; $z < 256; $z += 51) {
		$c1 = sprintf("%02x", $z);
			for ($y = 0; $y < 256; $y += 51) {
			$c2 = sprintf("%02x", $y);
			for ($x = 0; $x < 256; $x += 51) {
				$c3 = sprintf("%02x", $x);
				$selcolor = qq~#$c3$c2$c1~;
				print qq~<span title="$selcolor" style="float: left; background-color: $selcolor; width: 15px; height: 15px; margin-right: 1px; margin-bottom: 1px; border: 0px; font-size: 5px; cursor: pointer;" onclick="Pickshowcolor('$selcolor')">&nbsp;</span>~;
			}
		}
	}
	print qq~
	<span style="float: left; background-color: #222222; width: 15px; height: 15px; margin-right: 1px; margin-bottom: 1px; border: 0px; font-size: 5px; cursor: pointer;" onclick="Pickshowcolor('#222222')">&nbsp;</span>
	<span style="float: left; background-color: #333333; width: 15px; height: 15px; margin-right: 1px; margin-bottom: 1px; border: 0px; font-size: 5px; cursor: pointer;" onclick="Pickshowcolor('#333333')">&nbsp;</span>
	<span style="float: left; background-color: #444444; width: 15px; height: 15px; margin-right: 1px; margin-bottom: 1px; border: 0px; font-size: 5px; cursor: pointer;" onclick="Pickshowcolor('#444444')">&nbsp;</span>
	<span style="float: left; background-color: #555555; width: 15px; height: 15px; margin-right: 1px; margin-bottom: 1px; border: 0px; font-size: 5px; cursor: pointer;" onclick="Pickshowcolor('#555555')">&nbsp;</span>
	<span style="float: left; background-color: #666666; width: 15px; height: 15px; margin-right: 1px; margin-bottom: 1px; border: 0px; font-size: 5px; cursor: pointer;" onclick="Pickshowcolor('#666666')">&nbsp;</span>
	<span style="float: left; background-color: #777777; width: 15px; height: 15px; margin-right: 1px; margin-bottom: 1px; border: 0px; font-size: 5px; cursor: pointer;" onclick="Pickshowcolor('#777777')">&nbsp;</span>
	<span style="float: left; background-color: #888888; width: 15px; height: 15px; margin-right: 1px; margin-bottom: 1px; border: 0px; font-size: 5px; cursor: pointer;" onclick="Pickshowcolor('#888888')">&nbsp;</span>
	<span style="float: left; background-color: #aaaaaa; width: 15px; height: 15px; margin-right: 1px; margin-bottom: 1px; border: 0px; font-size: 5px; cursor: pointer;" onclick="Pickshowcolor('#aaaaaa')">&nbsp;</span>
	<span style="float: left; background-color: #bbbbbb; width: 15px; height: 15px; margin-right: 1px; margin-bottom: 1px; border: 0px; font-size: 5px; cursor: pointer;" onclick="Pickshowcolor('#bbbbbb')">&nbsp;</span>
	<span style="float: left; background-color: #cccccc; width: 15px; height: 15px; margin-right: 1px; margin-bottom: 1px; border: 0px; font-size: 5px; cursor: pointer;" onclick="Pickshowcolor('#cccccc')">&nbsp;</span>
	<span style="float: left; background-color: #dddddd; width: 15px; height: 15px; margin-right: 1px; margin-bottom: 1px; border: 0px; font-size: 5px; cursor: pointer;" onclick="Pickshowcolor('#dddddd')">&nbsp;</span>
	<span style="float: left; background-color: #eeeeee; width: 15px; height: 15px; margin-right: 1px; margin-bottom: 1px; border: 0px; font-size: 5px; cursor: pointer;" onclick="Pickshowcolor('#eeeeee')">&nbsp;</span>
	</div>
	<div style="position: relative; top: 9px; left: 5px; width: 289px; height: 17px; border: 1px black solid;">
	<span name="viewcolor" id="viewcolor" style="float: left; background-color: $selcolor; width: 192px; height: 17px; border-right: 1px black solid; font-size: 5px; cursor: pointer;" onclick="Pickshowcolor(this.style.backgroundColor)">&nbsp;</span>
	<span style="float: right; width: 72px; height: 15px;">
	<input class="windowbg" name="viewcode" id="viewcode" type="text" style="width: 70px; font-size: 11px; border: 0px; display: inline;" readonly="readonly" />
	</span>
	</div>
	<div class="catbg" style="position: relative; top: 15px; left: 10px; width: 277px; height: 56px; border-width: 1px; border-style: outset;">
	<img src="$defaultimagesdir/knapbagrms01.gif" style="position: absolute; top: 0px; left: 0px; z-index: 1; width: 275px; height: 16px;" />
	<img id="knapImg1" src="$defaultimagesdir/knapred.gif" class="skyd" style="position: absolute; left: 4px; top: 2px; cursor: pointer; z-index: 2; width: 13px; height: 15px;" />
	<img src="$defaultimagesdir/knapbagrms01.gif" style="position: absolute; top: 16px; left: 0px; z-index: 1; width: 275px; height: 16px;" />
	<img id="knapImg2" src="$defaultimagesdir/knapgreen.gif" class="skyd" style="position: absolute; left: 4px; top: 18px; cursor: pointer; z-index: 2; width: 13px; height: 15px;" />
	<img src="$defaultimagesdir/knapbagrms01.gif" style="position: absolute; top: 32px; left: 0px; z-index: 1; width: 275px; height: 16px;" />
	<img id="knapImg3" src="$defaultimagesdir/knapblue.gif" class="skyd" style="position: absolute; left: 4px; top: 34px; cursor: pointer; z-index: 2; width: 13px; height: 15px;" />
	</div>
</div>

<script language="JavaScript1.2" src="$yyhtml_root/palette.js" type="text/javascript"></script>

</body>
</html>
~;
}

1;